#include "FPU.h"
#include <math.h>
#include "complejos.h"

            COMPLEJO complex_sum(COMPLEJO c1, COMPLEJO c2) // c1 + c2
            {
                COMPLEJO ctmp=COMPLEJO_DEFAULTS;
               ctmp.real=c1.real + c2.real;
               ctmp.imag=c1.imag + c2.imag;
               return (ctmp);
            }
 
            COMPLEJO complex_dif(COMPLEJO c1, COMPLEJO c2) // c1 - c2
            {
                COMPLEJO ctmp=COMPLEJO_DEFAULTS;
               ctmp.real=c1.real - c2.real;
               ctmp.imag=c1.imag - c2.imag;
               return (ctmp);
            }
 
            COMPLEJO complex_mul(COMPLEJO c1, COMPLEJO c2) // c1 * c2
            {
               COMPLEJO ctmp=COMPLEJO_DEFAULTS;
               ctmp.real=(c1.real * c2.real) - (c1.imag * c2.imag);
               ctmp.imag=(c1.real * c2.imag) + (c1.imag * c2.real);
               return (ctmp);
            }
 
            COMPLEJO complex_div(COMPLEJO c1, COMPLEJO c2) // c1 / c2
            {
               COMPLEJO ctmp=COMPLEJO_DEFAULTS;
			   float div=0.0;
               div=(c2.real * c2.real) + (c2.imag * c2.imag);
               ctmp.real=(c1.real * c2.real) + (c1.imag * c2.imag);
			   if (div==0.0)
				div=1E-12;
               ctmp.real/=div;
               ctmp.imag=(c1.imag * c2.real)-(c1.real * c2.imag);
               ctmp.imag/=div;
               return (ctmp);
            }
            COMPLEJO complex_getconjugate(COMPLEJO c) 
            {
               COMPLEJO ctmp=COMPLEJO_DEFAULTS;
               ctmp.real=c.real;
               ctmp.imag=c.imag * (-1);
               return (ctmp);
            }
            COMPLEJO complex_getreciprocal(COMPLEJO c) 
            {
               COMPLEJO t=COMPLEJO_DEFAULTS;
               float div=0.0;
               t.real=c.real;
               t.imag=c.imag * (-1);
               div=(c.real * c.real) + (c.imag * c.imag);
			   if (div==0.0)
				div=1E-12;
               t.real/=div;
               t.imag/=div;
               return (t);
            }
 
            float complex_getmodulus(COMPLEJO c) 
            {
               float z=0.0;
               z=(c.real * c.real)+(c.imag * c.imag);
               z=sqrt(z);
               return z;
            }
            float complex_getphase(COMPLEJO c) 
            {
               float ph=0.0;
	   
			   	if(c.real!= 0.0){
	             ph=atan2(c.imag,c.real);
				}
				else{
					if(c.imag>0)
						ph= HALFPI;
					else if(c.imag<0)
						ph= NHALFPI;
					else
						ph=0;
				}
               return ph;
            }
            COMPLEJO complex_setdata(COMPLEJO c, float r,float i)
            {
               c.real=r;
               c.imag=i;
			   return(c);
            }

            float complex_getreal(COMPLEJO c)
            {
                 return (c.real);
            }

            float complex_getimaginary(COMPLEJO c)
            {
                 return (c.imag);
            }

            int complex_equal(COMPLEJO c1, COMPLEJO c2)
            {
             return ((c1.real==c2.real)&&(c1.imag==c2.imag) ? 1 : 0);
            }

	